/* Problem URL: https://codeforces.com/contest/1674/problem/E */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (size_t i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (size_t i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

ll inf = INT64_MAX >> 3;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vi a(n);
    cin >> a;

    ll ans = inf;
    ll minimal = inf;

    rep(i, n) {
        ll m = a[i] / 2 + a[i] % 2;
        rmin(ans, minimal + m);
        rmin(minimal, m);
    }

    rep(i, n) {
        ll ans1 = a[i] / 2 + a[i] % 2;

        ll ans2 = inf;
        if (i > 0) {
            ans2 = a[i - 1];
            rmin(ans, ans1 + max((ans2 - ans1) / 2 + (ans2 - ans1) % 2, 0LL));
        }

        ll ans3 = inf;
        if (i < n - 1) {
            ans3 = a[i + 1];
            rmin(ans, ans1 + max((ans3 - ans1) / 2 + (ans3 - ans1) % 2, 0LL));
        }

        rmin(ans, max((ans2 - ans1) / 2 + (ans2 - ans1) % 2, 0LL) + max((ans3 - ans1) / 2 + (ans3 - ans1) % 2, 0LL) + min(ans1, max(ans2, ans3)));
    }

    cout << ans << '\n';
}
